//	x^xK[iȈՔŁj
//	wt]xH쎺	http://jsdiy.web.fc2.com

/*
y|[gΉz	ATmega88P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	-	-	-	-	-	-	-	-		--
portC	x	x	SCL	SDA	-	-	-	-		TWI(I2C)
portD	-	-	-	-	-	-	TXD	-		fobOo

yATmega88Pz
|CCCCCC---BBBBB|
|543210GRV54321|
>              |
|601234VG675670|
|CDDDDD--BBDDDB|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100010(62), Hi:11011111(DF)
Low: 01100010 (62)
||||++++-- CKSEL[3:0] VXeNbNI
||++-- SUT[1:0] N
|+-- CKOUT (0:PB0ɃVXeNbNo)
+-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11111 (DF)
|||||+++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
||||+-- EESAVE (EEPROM 1:, 0:ێ)
|||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
|+-- DWEN (On-ChipfobO 1:, 0:L)
+-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----001 (F9)
||+-- BOOTRST f[^V[gQ
++-- BOOTSZ[1:0] f[^V[gQ

yrhz
Atmel Studio 6 (Version: 6.0.1996 - Service Pack 2)
AVR Toolchain 8 Bit / Version: 3.4.1.830 - GCC  4.6.2
ATmega88P 1MHzi8MHz8j	œKIvV: -Os

yXVz
2013/10/06	v1.00	
	Program Memory Usage 	:	2750 bytes   33.6 % Full
	Data Memory Usage 		:	534 bytes   52.1 % Full
	EEPROM Memory Usage 	:	20 bytes   3.9 % Full
*/

#include <avr/io.h>
#include <avr/eeprom.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "comctrl.h"
#include "dht11lib.h"
#include "i2ceeprom.h"

//R[hif[^̕ۑ`j
typedef struct
{
	uint16_t index;		//R[h̃CfbNX
	
	//Jňoߎ
	uint8_t day;	//255̎0֖߂
	uint8_t hour;	//24Ԃday֌Jオ
	uint8_t min;	//60hour֌Jオ
	
	//l
	uint8_t humidity;	//Ύx(%RH)
	uint8_t temperature;	//C('C)
} TRecord;

//Jn
typedef struct
{
	uint16_t yyyy;	//4
	uint16_t mmdd;	//
	uint16_t hhmm;	//i24Ԑj
} TStartDate;

static	EEMEM	TI2CEepRom	EM_DevMem;		//foCXiI2C-EEPROM̃TCYȂǁj
static	EEMEM	uint8_t		EM_TimerMinute;	//Ԋuő肷邩
static	EEMEM	uint16_t	EM_SaveAdrs;	//̃R[hۑAhXiI2C-EEPROM̃AhXj
static	EEMEM	TRecord		EM_PrevRecord;	//̃R[h쐬̃x[XƂȂÕR[h
static	EEMEM	TStartDate	EM_StartDate;	//Jn

static	TI2CEepRom devMem;	//foCX\
static	uint8_t* dataBuf;	//f[^ǂݏobt@

static	void	ComAction();
static	void	SaveSensorData(uint8_t humidity, uint8_t temperature);
static	void	ResetInterruptParam();
static	void	ResetRecordSaveParam();
static	void	SetStartDate(uint8_t* buf);
static	uint8_t	GetStartDate(uint8_t* buf);

//TWI(I2C)̃WX^ݒ肷
//TWBR = (F_CPU / scl - 16) / (2 * prescale)
//TWSR:TWPS1,0 = 00:1, 01:4, 10:16, 11:64
static	void	TWI_Init()
{
	//TWBR=0x00,TWSR=0x00̂ƂSCL=62500HziF_CPU=1MHzɂőݒj
	TWBR = 0x00;
	TWSR = 0x00;
}

#define	I2CEEPROM_ChipSelectBits	0b000

//16bit^C}荞
volatile	uint8_t	bTC;
volatile	uint8_t	mmCount;
static	uint8_t timerMinute;
//
ISR(TIMER1_COMPA_vect)
{
	if (++mmCount >= timerMinute)
	{
		mmCount = 0;
		bTC = 1;
	}		
}

//^C}[֌W̕ϐZbg
static	void	ResetInterruptParam()
{
	TCNT1 = 0;
	mmCount = 0;
	bTC = 0;
}

int	main(void)
{
	uint8_t	humidity, temperature;
	dataBuf = comGetDataBuf();

	_delay_ms(100);
	
	//I2C-EEPROM̃foCXǂݍ
	//E񂪏NA܂͑O܂łPCxݒĂȂꍇAł͖ӖȒlǂݍ܂邱ƂɂȂB
	//	ō\ȂBKvɉPCANZXAݒemF^ύXB
	eeprom_busy_wait();
	eeprom_read_block(&devMem, &EM_DevMem, sizeof(TI2CEepRom));
	I2CEEPROM_SetDevice(&devMem);
	
	//16bit^C}[Zbg
	//TCCR1B:WGM13,WGM12; TCCR1A:WGM11,WGM10 = 0100:CTC
	//TCCR1B:CS12,CS11,CS10 = 001:Ȃ, 010:8, 011:64, 100:256, 101:1024
	TCCR1A	= (0b00 << WGM10);
	TCCR1B	= (0b01 << WGM12) | (0b101 << CS10);
	OCR1A	= 58594UL - 1;		//1MHz/1024 = 976.56JEg/b -> 60b58593.75JEg
	TIMSK1	= (1 << OCIE1A);	//rv荞݂
	
	//C^[o̐ݒǂݍ
	eeprom_busy_wait();
	timerMinute = eeprom_read_byte(&EM_TimerMinute);
	if (timerMinute == 0) timerMinute = 1;
	
	//VA|[g
	comInit();
	
	//TWI(I2C)
	TWI_Init();
	
	//荞݋
	ResetInterruptParam();
	sei();
	
	while (1)
	{
		//VAʐMĎ
		ComAction();
		
		//Ԍo߂Ď
		if (!bTC) continue;
		bTC = 0;
		
		//x^x𑪒肷
		humidity = temperature = 0;
		DHT11_GetValue(&humidity, &temperature);
		
		//lۑ
		SaveSensorData(humidity, temperature);
	}
	
	return 0;
}

//VAʐMĎ^R}h
static	void	ComAction()
{
	uint8_t	reqCommand, u8tmp;
	uint16_t w, memAdrs, dataLength, readLength;
	uint8_t isOK;
	
	//R}h҂
	reqCommand = comPolling();
	if (!comCmdExec(reqCommand)) return;	//PC̒ʐM͂Ȃ
	
	//荞݂~
	cli();
	
	memAdrs = comGetMemAdrs();
	dataLength = comGetDataLength();
	
	//̐U蕪
	//Eǂݏ́A܂R}hM̍}ƂĎg̃R}hԂB
	//	ďsAʂԂBƂ2iKANVB
	switch (reqCommand)
	{
	case COMCTRL_CMD_DEVINFO:
		comSendByte(COMCTRL_CMD_DEVINFO);
		comSendByte(COMCTRL_END_CODE);
		
		//łmemAdrs͏̃xƂėp
		if (memAdrs == 1)	//foCXύX
		{
			I2CEEPROM_DeviceInfo(&devMem, I2CEEPROM_ChipSelectBits, comGetByteData(0), comGetByteData(1));
			I2CEEPROM_SetDevice(&devMem);
			eeprom_busy_wait();	eeprom_write_block(&devMem, &EM_DevMem, sizeof(TI2CEepRom));
			
			//ƃR[hۑ֌W̃p[^Zbg
			ResetInterruptParam();
			ResetRecordSaveParam();
		}
		if (memAdrs == 2)	//C^[oύX
		{
			timerMinute = comGetByteData(0);
			eeprom_busy_wait();	eeprom_write_byte(&EM_TimerMinute, timerMinute);

			//֌W̃p[^Zbg
			ResetInterruptParam();
		}

		//݃ZbgĂlԂ
		comSendWord(devMem.memAdrsLast);
		comSendByte(devMem.pageSizeByte);
		comSendByte(timerMinute);
		break;

	case COMCTRL_CMD_STARTDATE:
		comSendByte(COMCTRL_CMD_STARTDATE);
		comSendByte(COMCTRL_END_CODE);
		
		//łmemAdrs͏̃xƂėp
		if (memAdrs == 1)	//JnVKݒi܂͕ύXj
		{
			ResetInterruptParam();
			ResetRecordSaveParam();
			SetStartDate(dataBuf);
		}
		
		//݃ZbgĂlԂ
		dataLength = GetStartDate(dataBuf);
		for (w = 0; w < dataLength; w++) comSendByte(dataBuf[w]);	//擾lԂ
		break;
	/*
	case COMCTRL_CMD_WRITE:
		comSendByte(COMCTRL_CMD_WRITE);
		comSendByte(COMCTRL_END_CODE);
		
		isOK = (dataLength == 1)
			? I2CEEPROM_WriteByte(memAdrs, comGetByteData(0))
			: I2CEEPROM_WriteBlock(memAdrs, dataBuf, dataLength);
		comSendByte(isOK ? COMCTRL_CMD_WRITE : COMCTRL_RET_ERROR);	//ۂԂ
		break;
	*/
	case COMCTRL_CMD_READ:
		comSendByte(COMCTRL_CMD_READ);
		comSendByte(COMCTRL_END_CODE);
		
		readLength = I2CEEPROM_ReadBlock(memAdrs, dataBuf, dataLength);
		if (readLength != dataLength) break;
		for (w = 0; w < readLength; w++) comSendByte(dataBuf[w]);	//擾lԂ
		break;
		
	case COMCTRL_CMD_ERASE:
		comSendByte(COMCTRL_CMD_ERASE);
		comSendByte(COMCTRL_END_CODE);
		
		//ƃR[hۑ֌W̃p[^Zbg
		ResetInterruptParam();
		ResetRecordSaveParam();
		
		//I2C-EEPROM
		u8tmp = comGetByteData(0);
		for (w = 0; w < devMem.pageSizeByte; w++) dataBuf[w] = u8tmp;
		isOK = I2CEEPROM_Erase(dataBuf);
		comSendByte(isOK ? COMCTRL_CMD_ERASE : COMCTRL_RET_ERROR);	//ۂԂ
		break;
		
	case COMCTRL_CMD_WHO:
		comSendMyName();
		break;
		
	default:	break;
	}
	
	//R}hɉMĂĂƂ
	comUsartRcvBufClear();
	
	//R}h̕ԐM
	comSendByte(COMCTRL_END_CODE);
	
	//荞݂ĊJ
	sei();
}

//f[^ۑ
//^AVREEPROM̈ɁAf[^I2C-EEPROMɕۑB
//EI2C-EEPROM̂ǂɉ̏񂪕ۑĂ邩ƂAVREEPROM̈ɕۑĂB
//	̂悤ɂI2C-EEPROM̑S̈ɑf[^ۑ̂߂ɎgB
static	void	SaveSensorData(uint8_t humidity, uint8_t temperature)
{
	TRecord record;
	uint8_t recordLength = sizeof(TRecord);
	uint16_t saveAdrs;

	//ÕR[hiXVṕjǂݍ
	eeprom_busy_wait();
	eeprom_read_block(&record, &EM_PrevRecord, recordLength);

	//ÕR[hɍ̃R[h
	//ECfbNXXVAoߎԍXVAZT[̒lB
	record.index++;
	record.min += timerMinute;
	if (record.min >= 60)
	{
		record.min -= 60;
		if (++record.hour >= 24)
		{
			record.hour -= 24;
			record.day++;	//256ڂ0ڂƂȂ
		}
	}
	record.humidity = humidity;
	record.temperature = temperature;

	//̕ۑAhX擾
	//Eۑ烁̈𒴂Ă܂ȂAAhX̑Ó`FbNB
	//E512Kbit(=64KByte)I2C-EEPROMɑ΂ăAhXvZƂA
	//	vZ̒lUINT16_MAX(0xFFFF)𒴂̂uint32_t^ŌvZB
	eeprom_busy_wait();
	saveAdrs = eeprom_read_word(&EM_SaveAdrs);
	if ((uint32_t)devMem.memAdrsLast + 1 < (uint32_t)saveAdrs + recordLength) saveAdrs = 0x0000;

	//R[hۑ
	I2CEEPROM_WriteBlock(saveAdrs, (uint8_t*)&record, recordLength);
	
	//AVREEPROM̈ɂR[hۑiXṼx[Xpj
	eeprom_busy_wait();
	eeprom_write_block(&record, &EM_PrevRecord, recordLength);

	//̕ۑAhXAVREEPROM̈ɕۑ
	//ẼAhX̑Óiۑ烁̈𒴂Ȃj́AۑɃ`FbN̂ƂB
	saveAdrs += recordLength;
	eeprom_busy_wait();
	eeprom_write_word(&EM_SaveAdrs, saveAdrs);
}

//I2C-EEPROM^ƂAf[^ۑɊւlZbg
//EI2C-EEPROMfoCX̃TCÝAł̓ZbgȂB
//EC^[o̓ZbgȂB
static	void	ResetRecordSaveParam()
{
	TRecord record;
	uint8_t zeroBuf[sizeof(TStartDate)] = {0};
	
	eeprom_busy_wait();
	eeprom_write_word(&EM_SaveAdrs, 0x0000);

	record.index = 0;
	record.day = record.hour = record.min = 0;
	eeprom_busy_wait();
	eeprom_write_block(&record, &EM_PrevRecord, sizeof(TRecord));

	SetStartDate(zeroBuf);
}

//JnZbg
static	void	SetStartDate(uint8_t* buf)
{
	eeprom_busy_wait();
	eeprom_write_block(buf, &EM_StartDate, sizeof(TStartDate));
}

//Jn擾
static	uint8_t	GetStartDate(uint8_t* buf)
{
	uint8_t length = sizeof(TStartDate);
	eeprom_busy_wait();
	eeprom_read_block(buf, &EM_StartDate, length);
	return length;
}
