//	xxZT[ DHT11W[̃Cu
//	wt]xH쎺	http://jsdiy.web.fc2.com
/*
yDHT11 f[^V[gz
EdAZT[肷܂ł̎Ԃ͎x^xƂ10bimin=6, typ=10, max=15bjB
EԊu1b󂯂B

ygz
p̃vWFNgɁudht11lib.cvudht11lib.hvB
p̃t@Cňȉ̂悤ɋLqB

#include "dht11lib.h"
void func()
{
	uint8_t isOK;
	uint8_t humidity = 0, temperature = 0;
	isOK = DHT11_GetValue(&humidity, &temperature);
	if (isOK) display(humidity + "%RH " + temperature + "'C");
	else display("error");
}

yXVz
2013/09/20	v1.00	
*/

#include <avr/io.h>
#include <util/delay.h>
#include "dht11lib.h"

//MHiɂȂ܂ő҂
static	void	WaitForHi()
{
	while ((DHT11_PIN & DHT11_BIT) != DHT11_BIT){}
}

//MLoɂȂ܂ő҂
static	void	WaitForLo()
{
	while ((DHT11_PIN & DHT11_BIT) == DHT11_BIT){}
}

//Mo͕ɐ؂ւ
static	void	DDROut()
{
	DHT11_DDR |= DHT11_BIT;	//out
}

//M͕ɐ؂ւ
static	void	DDRIn()
{
	DHT11_DDR &= ~DHT11_BIT;	//in
}

//MLoɂ
static	void	SignalLo()
{
	DHT11_PORT &= ~DHT11_BIT;	//Lo
}

//MHiɂ
static	void	SignalHi()
{
	DHT11_PORT |= DHT11_BIT;	//Hi
}

//M̏Hi/Lol1/0ƂĎ擾
static	uint8_t	ReadSignalBit()
{
	return (DHT11_PIN & DHT11_BIT) ? 1 : 0;
}

//ZT[瑪l擾
//	humidity:		x̖߂li[ϐ
//		temperature:	x̖߂li[ϐ
//߂l	1:	cɑl
//			0:s	c͑삳Ȃ
uint8_t	DHT11_GetValue(uint8_t* humidity, uint8_t* temperature)
{
	//ZT[擾li[obt@
	//[0]x̐	[1]x̏iDHT11ł0x00j
	//[2]x̐	[3]x̏iDHT11ł0x00j
	//[4] `FbNTi[0]`[3]̘ả8bitj
	uint8_t sensorValue[5];
	
	uint8_t idx, b, bits, chksum, isOK;
	
	//ʐMJn
	//EMHȉԂŊJn邱ƁB
	//E18msȏLoɂHiɂB
	DDROut();
	SignalHi();
	SignalLo();	_delay_ms(20);
	SignalHi();
	DDRIn();
	
	//20`40usAZT[Lo
	//Lo80us80usHiiLoɕςj
	WaitForLo();
	WaitForHi();
	
	//f[^擾
	//EJnV[PX̊A܂͒Õf[^irbgj0/1ĂƂHȉԁB
	//	LouԂ玟̃f[^JnB
	//ELo50usB
	//ĚHiA26`28usȂurbg:0vA70usȂurbg:1v\B
	for (idx = 0; idx < 5; idx++)
	{
		bits = 0x00;
		for (b = 0; b < 8; b++)
		{
			WaitForLo();
			WaitForHi();
			_delay_us(40);	//28`70us̊Ԃ̒ŃTvO
			bits = (bits << 1) | ReadSignalBit();
		}
		sensorValue[idx] = bits;
	}
	
	//ZT[8bit*5=40bitƁAf[^M̍}50usLo𑗂ĂiHiɕςj
	WaitForHi();
	
	//f[^̑Ó`FbN
	chksum = 0x00;
	for (idx = 0; idx < 4; idx++)
		chksum += sensorValue[idx];
	isOK = (chksum == sensorValue[4]);
	
	if (isOK)
	{
		*humidity = sensorValue[0];
		*temperature = sensorValue[2];
	}	
	
	return isOK;
}
